/*

					Logic Scope AVR

			Copyrights 2009,  Yoshi Hiroshi


*/

/*
--------------------------------------------------
		Sampling Time Definitions
--------------------------------------------------
*/
#define LOG_SAMPLE_PERIOD_6_6M		    150
#define LOG_SAMPLE_PERIOD_5M		    200
#define LOG_SAMPLE_PERIOD_4M		    250
#define LOG_SAMPLE_PERIOD_2M		    500
#define LOG_SAMPLE_PERIOD_1M		   1000
#define LOG_SAMPLE_PERIOD_500K		   2000
#define LOG_SAMPLE_PERIOD_200K		   5000
#define LOG_SAMPLE_PERIOD_100K		  10000
#define LOG_SAMPLE_PERIOD_50K		  20000
#define LOG_SAMPLE_PERIOD_20K		  50000
#define LOG_SAMPLE_PERIOD_10K		 100000
#define LOG_SAMPLE_PERIOD_5K		 200000
#define LOG_SAMPLE_PERIOD_2K		 500000
#define LOG_SAMPLE_PERIOD_1K		1000000



/*
--------------------------------------------------
		Communication Command & Result Code
--------------------------------------------------
*/
#define COMMAND_CHECK				0x20
#define COMMAND_CHECK_REPLY			0x21
#define COMMAND_START				0x22
#define COMMAND_START_REPLY			0x23
#define COMMAND_LOGCOND				0x24
#define COMMAND_LOGCOND_REPLY		0x25
#define COMMAND_GETDATA				0x26
#define COMMAND_GETDATA_REPLY		0x27
#define COMMAND_REPLY_UNKNOWN		0xFF


#define COMMAND_REPLY_UNKNOWN_CHECK_CODE		0xF1
#define COMMAND_REPLY_UNKNOWN_CHECK_LENGTH		0xF2
#define COMMAND_REPLY_UNKNOWN_START_PERIOD		0xF3
#define COMMAND_REPLY_UNKNOWN_START_LENGTH		0xF4
#define COMMAND_REPLY_UNKNOWN_LOGCOND_CODE		0xF5
#define COMMAND_REPLY_UNKNOWN_LOGCOND_LENGTH	0xF6
#define COMMAND_REPLY_UNKNOWN_GETDATA_CODE		0xF7
#define COMMAND_REPLY_UNKNOWN_GETDATA_LENGTH	0xF8




/*
--------------------------------------------------
		Common Functions
--------------------------------------------------
*/
void replyUnknown(unsigned char reply);
void replyCheck();
void replyStartSampling(unsigned char reply, unsigned int size);
void replyEndSampling(unsigned int size);
void replyLogCond();
void replyLogData(unsigned int bufTop, unsigned int size);


void doCheckCommand();
void doStartCommand();
void doGetLogConditonCommand();
void doGetLogDataCommand();



