/*

					Logic Scope AVR

				   Support Functions

			Copyrights 2009,  Yoshi Hiroshi

*/

/*
------------------------------------------------------------
		Register Assignment
------------------------------------------------------------
*/

#define BAUD						38400

//----------------------------------------------------------
#define UART_DATA_REGISTER						UDR
#define UART_TRL_STATUS_A						UCSRA
#define 	UART_DATA_EMPTY_BIT					UDRE
#define 	UART_2X_SPEED_BIT					U2X
#define		UART_RECIEVE_COMPLETE_BIT			RXC
#define UART_TRL_STATUS_B						UCSRB
#define		UART_RECIEVER_ENABLE_BIT			RXEN
#define		UART_TRANSMITTER_ENABLE_BIT			TXEN
#define UART_TRL_STATUS_C						UCSRC
#define		UART_CHARACTER_SIZE					_BV(UCSZ1) | _BV(UCSZ0)
//#define UART_BAUD_RATE_REGISTER					UBRR
#define UART_BAUD_RATE_REGISTER_H				UBRRH
#define UART_BAUD_RATE_REGISTER_L				UBRRL
#define UART_TRANSMITTER_PORT_DIRECTION_SET		DDRD |= 0b00000010

//----------------------------------------------------------

/*
------------------------------------------------------------
		Function Definitions
------------------------------------------------------------
*/
#define UART_READ_WAIT_COMPLETION				1
#define UART_READ_RETURN_IMMIDIATE				0

void sendUART(unsigned char data);
void sendUART_HEX(unsigned char data);
void sendTermUART();
void checkTermUART();
unsigned char checkReceiveUART();
void inhibitReceiveUART(unsigned char flag);
unsigned char readUART(unsigned char flag);
unsigned char readUART_HEX();
void initUART();

